package de.mdelab.instanceGraphEditor.ui.editor;

import org.eclipse.gef.ContextMenuProvider;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.ui.actions.ActionFactory;

import de.mdelab.instanceGraphEditor.ui.actions.ExpandNodeAction;
import de.mdelab.instanceGraphEditor.ui.actions.HideChildrenAction;
import de.mdelab.instanceGraphEditor.ui.actions.HideNodeAction;
import de.mdelab.instanceGraphEditor.ui.actions.PrintOutNodeAction;


public class GraphicalEditorContextMenuProvider extends ContextMenuProvider {

    private ActionRegistry actionRegistry;

    public GraphicalEditorContextMenuProvider(EditPartViewer viewer, final ActionRegistry actionRegistry) {
        super(viewer);
        setActionRegistry(actionRegistry);
    }

    @Override
    public void buildContextMenu(IMenuManager menu) {
        GEFActionConstants.addStandardActionGroups(menu);

        IAction action;

//        action = getActionRegistry().getAction(ActionFactory.UNDO.getId());
//	      menu.appendToGroup(GEFActionConstants.GROUP_UNDO, action);
//        action = getActionRegistry().getAction(ActionFactory.REDO.getId());
//        menu.appendToGroup(GEFActionConstants.GROUP_UNDO, action);
       action = actionRegistry.getAction(ExpandNodeAction.EXPAND_NODE);
       menu.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
       action = actionRegistry.getAction(HideChildrenAction.HIDE_CHILDREN);
       menu.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
       action = actionRegistry.getAction(HideNodeAction.HIDE_NODE);
       menu.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
       action = actionRegistry.getAction(PrintOutNodeAction.PRINT_OUT);
       menu.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
    }

    private ActionRegistry getActionRegistry() {
        return actionRegistry;
    }

    private void setActionRegistry(final ActionRegistry actionRegistry) {
        this.actionRegistry = actionRegistry;
    }
}
