package de.mdelab.instanceGraphEditor.ui.figures;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;

public class SelfLinkAnchor  extends AbstractConnectionAnchor{
	
	
	public enum AnchorType{ SOURCE_ANCHOR , TARGET_ANCHOR}
	
	private AnchorType anchorType; 
	
	//true for source anchor , false for target anchor
	public SelfLinkAnchor(IFigure owner, AnchorType anchorType) {
		super(owner);
		this.anchorType = anchorType;
	}
	
	@Override
	public Point getLocation(Point reference) {
		Point anchor = new Point(); 
		Point nodeCenter =  getOwner().getBounds().getCenter();
		
		switch (anchorType) {
		case SOURCE_ANCHOR:
		{
			anchor.x = nodeCenter.x + getOwner().getBounds().width/2;
			anchor.y = nodeCenter.y;
		}
			break;
		case TARGET_ANCHOR:
		{
			anchor.x = nodeCenter.x;
			anchor.y = nodeCenter.y + getOwner().getBounds().height/2;
		}
		default:
			break;
		}

		return anchor;
	}
}
