package de.mdelab.instanceGraphEditor.ui.parts;

import java.util.Arrays;

import org.eclipse.draw2d.Bendpoint;
import org.eclipse.draw2d.BendpointConnectionRouter;
import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.RelativeBendpoint;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;

import de.mdelab.instanceGraphEditor.ui.model.SelfLink;
import de.mdelab.instanceGraphEditor.ui.parts.BorderRelativeBendpoint.Side;

public class SelfLinkEditPart extends LinkEditPart {
	
	public SelfLinkEditPart(SelfLink connection) {
		super(connection);
	}

	protected IFigure createFigure() {

		// add arrow to the end point of the line
		PolygonDecoration decor = new PolygonDecoration();
		decor.setTemplate(PolygonDecoration.TRIANGLE_TIP);
		PolylineConnection conn = new PolylineConnection();
		conn.setTargetDecoration(decor);

		// add Label to the adge
		ConnectionEndpointLocator relationshipLocator = new ConnectionEndpointLocator(conn, false);
		relationshipLocator.setVDistance(20);
		relationshipLocator.setUDistance(20);
		Label relationshipLabel = new Label("contains");
		conn.add(relationshipLabel, relationshipLocator);

		//add BendPoints of the Link 
		BendpointConnectionRouter router = new BendpointConnectionRouter();
		BorderRelativeBendpoint bp1 = new BorderRelativeBendpoint(conn, this, 25, 25, Side.RIGHT_MIDDLE);
		BorderRelativeBendpoint bp2 = new BorderRelativeBendpoint(conn, this, 25, 25, Side.RIGHT_BOTTOM);
		BorderRelativeBendpoint bp3 = new BorderRelativeBendpoint(conn, this, 25, 25, Side.BOTTOM_MIDDLE);
		conn.setConnectionRouter(router);
		router.setConstraint(conn, Arrays.asList(new Bendpoint[] { bp1,bp2,bp3 }));
		return conn;
	}
}