package de.mdelab.sdm.interpreter.code.debug.ui.launcher;

import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.debug.ui.AbstractLaunchConfigurationTabGroup;
import org.eclipse.debug.ui.CommonTab;
import org.eclipse.debug.ui.ILaunchConfigurationDialog;
import org.eclipse.debug.ui.ILaunchConfigurationTab;

public abstract class SDInterpreterLaunchTabGroup extends AbstractLaunchConfigurationTabGroup {

	public void createTabs(	final ILaunchConfigurationDialog p_dialog,
							final String p_mode ) {
		final ILaunchConfigurationTab mainTab;
		
		if ( ILaunchManager.DEBUG_MODE.equals( p_mode ) ) {
			mainTab = createDebugModeTab();
		}
		else {
			mainTab = createRunModeTab();
		}

		setTabs( new ILaunchConfigurationTab[]{ mainTab, new CommonTab() } );
	}
	
	protected abstract ILaunchConfigurationTab createDebugModeTab();
	
	protected abstract ILaunchConfigurationTab createRunModeTab();
}
