package de.mdelab.sdm.interpreter.core.debug.client.protocol.requests;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.net4j.signal.RemoteException;
import org.eclipse.net4j.signal.RequestWithConfirmation;
import org.eclipse.net4j.signal.SignalProtocol;

import de.mdelab.resourceSetSynchronizer.ConnectionUtil;
import de.mdelab.sdm.interpreter.core.debug.client.SDDebugClient;

public abstract class SDDebugProtocolCommandRequestWithConfirmation<StoryDiagramElement extends EObject, RESULT> extends RequestWithConfirmation<RESULT> {

	private final SDDebugClient<StoryDiagramElement, ?>	debugClient;

	public SDDebugProtocolCommandRequestWithConfirmation(SignalProtocol<?> protocol, Enum<?> literal,
			SDDebugClient<StoryDiagramElement, ?> debugClient)
	{
		super(protocol, literal);

		assert debugClient != null;

		this.debugClient = debugClient;
	}

	protected SDDebugClient<StoryDiagramElement, ?> getDebugClient() {
		return this.debugClient;
	}

    /* DB: Overridden to use a longer default timeout for requests
     * 
     * (non-Javadoc)
     * @see org.eclipse.net4j.signal.RequestWithConfirmation#send()
     */
    @Override
    public RESULT send() 
    throws Exception, RemoteException {
    	return super.send( ConnectionUtil.DEFAULT_CONNECTION_TIMEOUT );
    }
}
